]> git.karo-electronics.de Git - karo-tx-linux.git/commitdiff
Merge tag 'linux-kselftest-4.4-rc1' of git://git.kernel.org/pub/scm/linux/kernel...
authorLinus Torvalds <torvalds@linux-foundation.org>
Wed, 11 Nov 2015 04:46:45 +0000 (20:46 -0800)
committerLinus Torvalds <torvalds@linux-foundation.org>
Wed, 11 Nov 2015 04:46:45 +0000 (20:46 -0800)
Pull kselftest updates from Shuah Khan:
 "This 12 patch update for 4.4-rc1 consists of a new pstore test and
  fixes to existing tests"

* tag 'linux-kselftest-4.4-rc1' of git://git.kernel.org/pub/scm/linux/kernel/git/shuah/linux-kselftest:
  selftests: breakpoint: Actually build it
  selftests: vm: Try harder to allocate huge pages
  selftests: Make scripts executable
  selftests: kprobe: Choose an always-defined function to probe
  selftests: memfd: Stop unnecessary rebuilds
  selftests: Add missing #include directives
  selftests/seccomp: Be more precise with syscall arguments.
  selftests/seccomp: build and pass on arm64
  selftests: memfd_test: Revised STACK_SIZE to make it 16-byte aligned
  selftests/pstore: add pstore test scripts going with reboot
  selftests/pstore: add pstore test script for pre-reboot
  selftests: add .gitignore for efivarfs

22 files changed:
tools/testing/selftests/Makefile
tools/testing/selftests/breakpoints/Makefile
tools/testing/selftests/efivarfs/.gitignore [new file with mode: 0644]
tools/testing/selftests/ftrace/test.d/kprobe/add_and_remove.tc
tools/testing/selftests/ftrace/test.d/kprobe/busy_check.tc
tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args.tc
tools/testing/selftests/ftrace/test.d/kprobe/kprobe_ftrace.tc
tools/testing/selftests/ftrace/test.d/kprobe/kretprobe_args.tc
tools/testing/selftests/memfd/Makefile
tools/testing/selftests/memfd/memfd_test.c
tools/testing/selftests/memfd/run_fuse_test.sh [changed mode: 0644->0755]
tools/testing/selftests/mqueue/mq_open_tests.c
tools/testing/selftests/mqueue/mq_perf_tests.c
tools/testing/selftests/pstore/Makefile [new file with mode: 0644]
tools/testing/selftests/pstore/common_tests [new file with mode: 0755]
tools/testing/selftests/pstore/pstore_crash_test [new file with mode: 0755]
tools/testing/selftests/pstore/pstore_post_reboot_tests [new file with mode: 0755]
tools/testing/selftests/pstore/pstore_tests [new file with mode: 0755]
tools/testing/selftests/seccomp/seccomp_bpf.c
tools/testing/selftests/static_keys/test_static_keys.sh [changed mode: 0644->0755]
tools/testing/selftests/timers/nanosleep.c
tools/testing/selftests/vm/run_vmtests

index 4b4957b8df4e879a0d19098fdacce49658fce24a..c8edff6803d1db0b9b36585746c3ecaf45b6681c 100644 (file)
@@ -14,6 +14,7 @@ TARGETS += mount
 TARGETS += mqueue
 TARGETS += net
 TARGETS += powerpc
+TARGETS += pstore
 TARGETS += ptrace
 TARGETS += seccomp
 TARGETS += size
@@ -66,6 +67,9 @@ clean_hotplug:
                make -C $$TARGET clean; \
        done;
 
+run_pstore_crash:
+       make -C pstore run_crash
+
 INSTALL_PATH ?= install
 INSTALL_PATH := $(abspath $(INSTALL_PATH))
 ALL_SCRIPT := $(INSTALL_PATH)/run_kselftest.sh
index d27108b4f2081fe2d250e4de8c45bf02f7c73d4f..c0d957015f524d7ad7f6ab2a46be1a8d484a8ef9 100644 (file)
@@ -6,7 +6,7 @@ ifeq ($(ARCH),x86)
 TEST_PROGS := breakpoint_test
 endif
 
-all:
+all: $(TEST_PROGS)
 
 include ../lib.mk
 
diff --git a/tools/testing/selftests/efivarfs/.gitignore b/tools/testing/selftests/efivarfs/.gitignore
new file mode 100644 (file)
index 0000000..3361849
--- /dev/null
@@ -0,0 +1,2 @@
+create-read
+open-unlink
index a5a426211129bd63cd7c6e0fadcf260998570735..c3843ed49bf6dfe268971e7d013b795ae30e7b4f 100644 (file)
@@ -5,7 +5,7 @@
 
 echo 0 > events/enable
 echo > kprobe_events
-echo p:myevent do_fork > kprobe_events
+echo p:myevent _do_fork > kprobe_events
 grep myevent kprobe_events
 test -d events/kprobes/myevent
 echo > kprobe_events
index d8c7bb6581fe9e51479ff02b92027fa07aef5c00..74507db8bbc89e1b3a4594ec948a81783584402b 100644 (file)
@@ -5,7 +5,7 @@
 
 echo 0 > events/enable
 echo > kprobe_events
-echo p:myevent do_fork > kprobe_events
+echo p:myevent _do_fork > kprobe_events
 test -d events/kprobes/myevent
 echo 1 > events/kprobes/myevent/enable
 echo > kprobe_events && exit 1 # this must fail
index c45ee2761354e716a8c6f3f926edcf23fef8a865..64949d4eda699af40f42c74f6408a14106893721 100644 (file)
@@ -5,7 +5,7 @@
 
 echo 0 > events/enable
 echo > kprobe_events
-echo 'p:testprobe do_fork $stack $stack0 +0($stack)' > kprobe_events
+echo 'p:testprobe _do_fork $stack $stack0 +0($stack)' > kprobe_events
 grep testprobe kprobe_events
 test -d events/kprobes/testprobe
 echo 1 > events/kprobes/testprobe/enable
index ab41d2b29841ceb149d59a51649467ec4136e3e1..d6f2f4965697a8a2e583087121283f5012d12ae4 100644 (file)
@@ -6,31 +6,31 @@ grep function available_tracers || exit_unsupported # this is configurable
 
 # prepare
 echo nop > current_tracer
-echo do_fork > set_ftrace_filter
+echo _do_fork > set_ftrace_filter
 echo 0 > events/enable
 echo > kprobe_events
-echo 'p:testprobe do_fork' > kprobe_events
+echo 'p:testprobe _do_fork' > kprobe_events
 
 # kprobe on / ftrace off
 echo 1 > events/kprobes/testprobe/enable
 echo > trace
 ( echo "forked")
 grep testprobe trace
-! grep 'do_fork <-' trace
+! grep '_do_fork <-' trace
 
 # kprobe on / ftrace on
 echo function > current_tracer
 echo > trace
 ( echo "forked")
 grep testprobe trace
-grep 'do_fork <-' trace
+grep '_do_fork <-' trace
 
 # kprobe off / ftrace on
 echo 0 > events/kprobes/testprobe/enable
 echo > trace
 ( echo "forked")
 ! grep testprobe trace
-grep 'do_fork <-' trace
+grep '_do_fork <-' trace
 
 # kprobe on / ftrace on
 echo 1 > events/kprobes/testprobe/enable
@@ -38,14 +38,14 @@ echo function > current_tracer
 echo > trace
 ( echo "forked")
 grep testprobe trace
-grep 'do_fork <-' trace
+grep '_do_fork <-' trace
 
 # kprobe on / ftrace off
 echo nop > current_tracer
 echo > trace
 ( echo "forked")
 grep testprobe trace
-! grep 'do_fork <-' trace
+! grep '_do_fork <-' trace
 
 # cleanup
 echo nop > current_tracer
index 31717985acc7f1fa972fea07b4fc149d4d456c18..0d09546258fde3b6c327bc6a4d8e67e14647de15 100644 (file)
@@ -5,7 +5,7 @@
 
 echo 0 > events/enable
 echo > kprobe_events
-echo 'r:testprobe2 do_fork $retval' > kprobe_events
+echo 'r:testprobe2 _do_fork $retval' > kprobe_events
 grep testprobe2 kprobe_events
 test -d events/kprobes/testprobe2
 echo 1 > events/kprobes/testprobe2/enable
index 3e7eb7972511c657af9ca54e6468542a42a5bd33..fd396ac811b6a73f086e605ef93e0d2c92401ad6 100644 (file)
@@ -4,16 +4,16 @@ CFLAGS += -I../../../../include/uapi/
 CFLAGS += -I../../../../include/
 CFLAGS += -I../../../../usr/include/
 
-all:
-       $(CC) $(CFLAGS) memfd_test.c -o memfd_test
-
 TEST_PROGS := memfd_test
 
+all: $(TEST_PROGS)
+
 include ../lib.mk
 
-build_fuse:
-       $(CC) $(CFLAGS) fuse_mnt.c `pkg-config fuse --cflags --libs` -o fuse_mnt
-       $(CC) $(CFLAGS) fuse_test.c -o fuse_test
+build_fuse: fuse_mnt fuse_test
+
+fuse_mnt.o: CFLAGS += $(shell pkg-config fuse --cflags)
+fuse_mnt: LDFLAGS += $(shell pkg-config fuse --libs)
 
 run_fuse: build_fuse
        @./run_fuse_test.sh || echo "fuse_test: [FAIL]"
index 0b9eafb7ab7bc1cc0282a4eec26bad50786a23fe..26546892cd545e954a559ade36cba823ac0bff18 100644 (file)
 #include <sys/mman.h>
 #include <sys/stat.h>
 #include <sys/syscall.h>
+#include <sys/wait.h>
 #include <unistd.h>
 
 #define MFD_DEF_SIZE 8192
-#define STACK_SIZE 65535
+#define STACK_SIZE 65536
 
 static int sys_memfd_create(const char *name,
                            unsigned int flags)
old mode 100644 (file)
new mode 100755 (executable)
index 9c1a5d359055f475b00cef6d053d14a2ab22c8aa..e0a74bd207a547c865f2e352f186a5b4cdf14da6 100644 (file)
@@ -31,6 +31,7 @@
 #include <sys/resource.h>
 #include <sys/stat.h>
 #include <mqueue.h>
+#include <error.h>
 
 static char *usage =
 "Usage:\n"
index 8519e9ee97e3d3e4a344e798cabf5b38edfff602..8188f72de93c2ae35884a0d2a3cebc9c7a3c1bf5 100644 (file)
@@ -37,6 +37,7 @@
 #include <sys/stat.h>
 #include <mqueue.h>
 #include <popt.h>
+#include <error.h>
 
 static char *usage =
 "Usage:\n"
diff --git a/tools/testing/selftests/pstore/Makefile b/tools/testing/selftests/pstore/Makefile
new file mode 100644 (file)
index 0000000..bd7abe2
--- /dev/null
@@ -0,0 +1,15 @@
+# Makefile for pstore selftests.
+# Expects pstore backend is registered.
+
+all:
+
+TEST_PROGS := pstore_tests pstore_post_reboot_tests
+TEST_FILES := common_tests pstore_crash_test
+
+include ../lib.mk
+
+run_crash:
+       @sh pstore_crash_test || { echo "pstore_crash_test: [FAIL]"; exit 1; }
+
+clean:
+       rm -rf logs/* *uuid
diff --git a/tools/testing/selftests/pstore/common_tests b/tools/testing/selftests/pstore/common_tests
new file mode 100755 (executable)
index 0000000..3ea64d7
--- /dev/null
@@ -0,0 +1,83 @@
+#!/bin/sh
+
+# common_tests - Shell script commonly used by pstore test scripts
+#
+# Copyright (C) Hitachi Ltd., 2015
+#  Written by Hiraku Toyooka <hiraku.toyooka.gu@hitachi.com>
+#
+# Released under the terms of the GPL v2.
+
+# Utilities
+errexit() { # message
+    echo "Error: $1" 1>&2
+    exit 1
+}
+
+absdir() { # file_path
+    (cd `dirname $1`; pwd)
+}
+
+show_result() { # result_value
+    if [ $1 -eq 0 ]; then
+       prlog "ok"
+    else
+       prlog "FAIL"
+       rc=1
+    fi
+}
+
+check_files_exist() { # type of pstorefs file
+    if [ -e ${1}-${backend}-0 ]; then
+       prlog "ok"
+       for f in `ls ${1}-${backend}-*`; do
+            prlog -e "\t${f}"
+       done
+    else
+       prlog "FAIL"
+       rc=1
+    fi
+}
+
+operate_files() { # tested value, files, operation
+    if [ $1 -eq 0 ]; then
+       prlog
+       for f in $2; do
+           prlog -ne "\t${f} ... "
+           # execute operation
+           $3 $f
+           show_result $?
+       done
+    else
+       prlog " ... FAIL"
+       rc=1
+    fi
+}
+
+# Parameters
+TEST_STRING_PATTERN="Testing pstore: uuid="
+UUID=`cat /proc/sys/kernel/random/uuid`
+TOP_DIR=`absdir $0`
+LOG_DIR=$TOP_DIR/logs/`date +%Y%m%d-%H%M%S`_${UUID}/
+REBOOT_FLAG=$TOP_DIR/reboot_flag
+
+# Preparing logs
+LOG_FILE=$LOG_DIR/`basename $0`.log
+mkdir -p $LOG_DIR || errexit "Failed to make a log directory: $LOG_DIR"
+date > $LOG_FILE
+prlog() { # messages
+    /bin/echo "$@" | tee -a $LOG_FILE
+}
+
+# Starting tests
+rc=0
+prlog "=== Pstore unit tests (`basename $0`) ==="
+prlog "UUID="$UUID
+
+prlog -n "Checking pstore backend is registered ... "
+backend=`cat /sys/module/pstore/parameters/backend`
+show_result $?
+prlog -e "\tbackend=${backend}"
+prlog -e "\tcmdline=`cat /proc/cmdline`"
+if [ $rc -ne 0 ]; then
+    exit 1
+fi
diff --git a/tools/testing/selftests/pstore/pstore_crash_test b/tools/testing/selftests/pstore/pstore_crash_test
new file mode 100755 (executable)
index 0000000..1a4afe5
--- /dev/null
@@ -0,0 +1,30 @@
+#!/bin/sh
+
+# pstore_crash_test - Pstore test shell script which causes crash and reboot
+#
+# Copyright (C) Hitachi Ltd., 2015
+#  Written by Hiraku Toyooka <hiraku.toyooka.gu@hitachi.com>
+#
+# Released under the terms of the GPL v2.
+
+# exit if pstore backend is not registered
+. ./common_tests
+
+prlog "Causing kernel crash ..."
+
+# enable all functions triggered by sysrq
+echo 1 > /proc/sys/kernel/sysrq
+# setting to reboot in 3 seconds after panic
+echo 3 > /proc/sys/kernel/panic
+
+# save uuid file by different name because next test execution will replace it.
+mv $TOP_DIR/uuid $TOP_DIR/prev_uuid
+
+# create a file as reboot flag
+touch $REBOOT_FLAG
+sync
+
+# cause crash
+# Note: If you use kdump and want to see kmesg-* files after reboot, you should
+#       specify 'crash_kexec_post_notifiers' in 1st kernel's cmdline.
+echo c > /proc/sysrq-trigger
diff --git a/tools/testing/selftests/pstore/pstore_post_reboot_tests b/tools/testing/selftests/pstore/pstore_post_reboot_tests
new file mode 100755 (executable)
index 0000000..6ccb154
--- /dev/null
@@ -0,0 +1,77 @@
+#!/bin/sh
+
+# pstore_post_reboot_tests - Check pstore's behavior after crash/reboot
+#
+# Copyright (C) Hitachi Ltd., 2015
+#  Written by Hiraku Toyooka <hiraku.toyooka.gu@hitachi.com>
+#
+# Released under the terms of the GPL v2.
+
+. ./common_tests
+
+if [ -e $REBOOT_FLAG  ]; then
+    rm $REBOOT_FLAG
+else
+    prlog "pstore_crash_test has not been executed yet. we skip further tests."
+    exit 0
+fi
+
+prlog -n "Mounting pstore filesystem ... "
+mount_info=`grep pstore /proc/mounts`
+if [ $? -eq 0 ]; then
+    mount_point=`echo ${mount_info} | cut -d' ' -f2 | head -n1`
+    prlog "ok"
+else
+    mount none /sys/fs/pstore -t pstore
+    if [ $? -eq 0 ]; then
+       mount_point=`grep pstore /proc/mounts | cut -d' ' -f2 | head -n1`
+       prlog "ok"
+    else
+       prlog "FAIL"
+       exit 1
+    fi
+fi
+
+cd ${mount_point}
+
+prlog -n "Checking dmesg files exist in pstore filesystem ... "
+check_files_exist dmesg
+
+prlog -n "Checking console files exist in pstore filesystem ... "
+check_files_exist console
+
+prlog -n "Checking pmsg files exist in pstore filesystem ... "
+check_files_exist pmsg
+
+prlog -n "Checking dmesg files contain oops end marker"
+grep_end_trace() {
+    grep -q "\---\[ end trace" $1
+}
+files=`ls dmesg-${backend}-*`
+operate_files $? "$files" grep_end_trace
+
+prlog -n "Checking console file contains oops end marker ... "
+grep -q "\---\[ end trace" console-${backend}-0
+show_result $?
+
+prlog -n "Checking pmsg file properly keeps the content written before crash ... "
+prev_uuid=`cat $TOP_DIR/prev_uuid`
+if [ $? -eq 0 ]; then
+    nr_matched=`grep -c "$TEST_STRING_PATTERN" pmsg-${backend}-0`
+    if [ $nr_matched -eq 1 ]; then
+       grep -q "$TEST_STRING_PATTERN"$prev_uuid pmsg-${backend}-0
+       show_result $?
+    else
+       prlog "FAIL"
+       rc=1
+    fi
+else
+    prlog "FAIL"
+    rc=1
+fi
+
+prlog -n "Removing all files in pstore filesystem "
+files=`ls *-${backend}-*`
+operate_files $? "$files" rm
+
+exit $rc
diff --git a/tools/testing/selftests/pstore/pstore_tests b/tools/testing/selftests/pstore/pstore_tests
new file mode 100755 (executable)
index 0000000..f25d2a3
--- /dev/null
@@ -0,0 +1,30 @@
+#!/bin/sh
+
+# pstore_tests - Check pstore's behavior before crash/reboot
+#
+# Copyright (C) Hitachi Ltd., 2015
+#  Written by Hiraku Toyooka <hiraku.toyooka.gu@hitachi.com>
+#
+# Released under the terms of the GPL v2.
+
+. ./common_tests
+
+prlog -n "Checking pstore console is registered ... "
+dmesg | grep -q "console \[pstore"
+show_result $?
+
+prlog -n "Checking /dev/pmsg0 exists ... "
+test -e /dev/pmsg0
+show_result $?
+
+prlog -n "Writing unique string to /dev/pmsg0 ... "
+if [ -e "/dev/pmsg0" ]; then
+    echo "${TEST_STRING_PATTERN}""$UUID" > /dev/pmsg0
+    show_result $?
+    echo "$UUID" > $TOP_DIR/uuid
+else
+    prlog "FAIL"
+    rc=1
+fi
+
+exit $rc
index 770f47adf2958b9970b993d2fee57c489a9cd1e2..e38cc54942dbf298dd1b880e3eabf5a9f2af29e6 100644 (file)
 #include <linux/prctl.h>
 #include <linux/ptrace.h>
 #include <linux/seccomp.h>
-#include <poll.h>
 #include <pthread.h>
 #include <semaphore.h>
 #include <signal.h>
 #include <stddef.h>
 #include <stdbool.h>
 #include <string.h>
+#include <time.h>
 #include <linux/elf.h>
 #include <sys/uio.h>
+#include <sys/utsname.h>
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/times.h>
 
 #define _GNU_SOURCE
 #include <unistd.h>
@@ -428,14 +432,16 @@ TEST_SIGNAL(KILL_one, SIGSYS)
 
 TEST_SIGNAL(KILL_one_arg_one, SIGSYS)
 {
+       void *fatal_address;
        struct sock_filter filter[] = {
                BPF_STMT(BPF_LD|BPF_W|BPF_ABS,
                        offsetof(struct seccomp_data, nr)),
-               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_getpid, 1, 0),
+               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_times, 1, 0),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_ALLOW),
                /* Only both with lower 32-bit for now. */
                BPF_STMT(BPF_LD|BPF_W|BPF_ABS, syscall_arg(0)),
-               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, 0x0C0FFEE, 0, 1),
+               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K,
+                       (unsigned long)&fatal_address, 0, 1),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_KILL),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_ALLOW),
        };
@@ -445,7 +451,8 @@ TEST_SIGNAL(KILL_one_arg_one, SIGSYS)
        };
        long ret;
        pid_t parent = getppid();
-       pid_t pid = getpid();
+       struct tms timebuf;
+       clock_t clock = times(&timebuf);
 
        ret = prctl(PR_SET_NO_NEW_PRIVS, 1, 0, 0, 0);
        ASSERT_EQ(0, ret);
@@ -454,17 +461,22 @@ TEST_SIGNAL(KILL_one_arg_one, SIGSYS)
        ASSERT_EQ(0, ret);
 
        EXPECT_EQ(parent, syscall(__NR_getppid));
-       EXPECT_EQ(pid, syscall(__NR_getpid));
-       /* getpid() should never return. */
-       EXPECT_EQ(0, syscall(__NR_getpid, 0x0C0FFEE));
+       EXPECT_LE(clock, syscall(__NR_times, &timebuf));
+       /* times() should never return. */
+       EXPECT_EQ(0, syscall(__NR_times, &fatal_address));
 }
 
 TEST_SIGNAL(KILL_one_arg_six, SIGSYS)
 {
+#ifndef __NR_mmap2
+       int sysno = __NR_mmap;
+#else
+       int sysno = __NR_mmap2;
+#endif
        struct sock_filter filter[] = {
                BPF_STMT(BPF_LD|BPF_W|BPF_ABS,
                        offsetof(struct seccomp_data, nr)),
-               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_getpid, 1, 0),
+               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, sysno, 1, 0),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_ALLOW),
                /* Only both with lower 32-bit for now. */
                BPF_STMT(BPF_LD|BPF_W|BPF_ABS, syscall_arg(5)),
@@ -478,7 +490,8 @@ TEST_SIGNAL(KILL_one_arg_six, SIGSYS)
        };
        long ret;
        pid_t parent = getppid();
-       pid_t pid = getpid();
+       int fd;
+       void *map1, *map2;
 
        ret = prctl(PR_SET_NO_NEW_PRIVS, 1, 0, 0, 0);
        ASSERT_EQ(0, ret);
@@ -486,10 +499,22 @@ TEST_SIGNAL(KILL_one_arg_six, SIGSYS)
        ret = prctl(PR_SET_SECCOMP, SECCOMP_MODE_FILTER, &prog);
        ASSERT_EQ(0, ret);
 
+       fd = open("/dev/zero", O_RDONLY);
+       ASSERT_NE(-1, fd);
+
        EXPECT_EQ(parent, syscall(__NR_getppid));
-       EXPECT_EQ(pid, syscall(__NR_getpid));
-       /* getpid() should never return. */
-       EXPECT_EQ(0, syscall(__NR_getpid, 1, 2, 3, 4, 5, 0x0C0FFEE));
+       map1 = (void *)syscall(sysno,
+               NULL, PAGE_SIZE, PROT_READ, MAP_PRIVATE, fd, PAGE_SIZE);
+       EXPECT_NE(MAP_FAILED, map1);
+       /* mmap2() should never return. */
+       map2 = (void *)syscall(sysno,
+                NULL, PAGE_SIZE, PROT_READ, MAP_PRIVATE, fd, 0x0C0FFEE);
+       EXPECT_EQ(MAP_FAILED, map2);
+
+       /* The test failed, so clean up the resources. */
+       munmap(map1, PAGE_SIZE);
+       munmap(map2, PAGE_SIZE);
+       close(fd);
 }
 
 /* TODO(wad) add 64-bit versus 32-bit arg tests. */
@@ -1247,8 +1272,8 @@ void change_syscall(struct __test_metadata *_metadata,
        ret = ptrace(PTRACE_GETREGSET, tracee, NT_PRSTATUS, &iov);
        EXPECT_EQ(0, ret);
 
-#if defined(__x86_64__) || defined(__i386__) || defined(__aarch64__) || \
-    defined(__powerpc__) || defined(__s390__)
+#if defined(__x86_64__) || defined(__i386__) || defined(__powerpc__) || \
+    defined(__s390__)
        {
                regs.SYSCALL_NUM = syscall;
        }
@@ -1262,6 +1287,18 @@ void change_syscall(struct __test_metadata *_metadata,
                EXPECT_EQ(0, ret);
        }
 
+#elif defined(__aarch64__)
+# ifndef NT_ARM_SYSTEM_CALL
+#  define NT_ARM_SYSTEM_CALL 0x404
+# endif
+       {
+               iov.iov_base = &syscall;
+               iov.iov_len = sizeof(syscall);
+               ret = ptrace(PTRACE_SETREGSET, tracee, NT_ARM_SYSTEM_CALL,
+                            &iov);
+               EXPECT_EQ(0, ret);
+       }
+
 #else
        ASSERT_EQ(1, 0) {
                TH_LOG("How is the syscall changed on this architecture?");
@@ -1272,6 +1309,8 @@ void change_syscall(struct __test_metadata *_metadata,
        if (syscall == -1)
                regs.SYSCALL_RET = 1;
 
+       iov.iov_base = &regs;
+       iov.iov_len = sizeof(regs);
        ret = ptrace(PTRACE_SETREGSET, tracee, NT_PRSTATUS, &iov);
        EXPECT_EQ(0, ret);
 }
@@ -2005,20 +2044,25 @@ TEST(syscall_restart)
                BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_read, 5, 0),
                BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_exit, 4, 0),
                BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_rt_sigreturn, 3, 0),
-               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_poll, 4, 0),
+               BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_nanosleep, 4, 0),
                BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_restart_syscall, 4, 0),
 
                /* Allow __NR_write for easy logging. */
                BPF_JUMP(BPF_JMP|BPF_JEQ|BPF_K, __NR_write, 0, 1),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_ALLOW),
                BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_KILL),
-               BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_TRACE|0x100), /* poll */
-               BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_TRACE|0x200), /* restart */
+               /* The nanosleep jump target. */
+               BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_TRACE|0x100),
+               /* The restart_syscall jump target. */
+               BPF_STMT(BPF_RET|BPF_K, SECCOMP_RET_TRACE|0x200),
        };
        struct sock_fprog prog = {
                .len = (unsigned short)ARRAY_SIZE(filter),
                .filter = filter,
        };
+#if defined(__arm__)
+       struct utsname utsbuf;
+#endif
 
        ASSERT_EQ(0, pipe(pipefd));
 
@@ -2027,10 +2071,7 @@ TEST(syscall_restart)
        if (child_pid == 0) {
                /* Child uses EXPECT not ASSERT to deliver status correctly. */
                char buf = ' ';
-               struct pollfd fds = {
-                       .fd = pipefd[0],
-                       .events = POLLIN,
-               };
+               struct timespec timeout = { };
 
                /* Attach parent as tracer and stop. */
                EXPECT_EQ(0, ptrace(PTRACE_TRACEME));
@@ -2054,10 +2095,11 @@ TEST(syscall_restart)
                        TH_LOG("Failed to get sync data from read()");
                }
 
-               /* Start poll to be interrupted. */
+               /* Start nanosleep to be interrupted. */
+               timeout.tv_sec = 1;
                errno = 0;
-               EXPECT_EQ(1, poll(&fds, 1, -1)) {
-                       TH_LOG("Call to poll() failed (errno %d)", errno);
+               EXPECT_EQ(0, nanosleep(&timeout, NULL)) {
+                       TH_LOG("Call to nanosleep() failed (errno %d)", errno);
                }
 
                /* Read final sync from parent. */
@@ -2082,14 +2124,14 @@ TEST(syscall_restart)
        ASSERT_EQ(0, ptrace(PTRACE_CONT, child_pid, NULL, 0));
        ASSERT_EQ(1, write(pipefd[1], ".", 1));
 
-       /* Wait for poll() to start. */
+       /* Wait for nanosleep() to start. */
        ASSERT_EQ(child_pid, waitpid(child_pid, &status, 0));
        ASSERT_EQ(true, WIFSTOPPED(status));
        ASSERT_EQ(SIGTRAP, WSTOPSIG(status));
        ASSERT_EQ(PTRACE_EVENT_SECCOMP, (status >> 16));
        ASSERT_EQ(0, ptrace(PTRACE_GETEVENTMSG, child_pid, NULL, &msg));
        ASSERT_EQ(0x100, msg);
-       EXPECT_EQ(__NR_poll, get_syscall(_metadata, child_pid));
+       EXPECT_EQ(__NR_nanosleep, get_syscall(_metadata, child_pid));
 
        /* Might as well check siginfo for sanity while we're here. */
        ASSERT_EQ(0, ptrace(PTRACE_GETSIGINFO, child_pid, NULL, &info));
@@ -2100,7 +2142,7 @@ TEST(syscall_restart)
        /* Verify signal delivery came from child (seccomp-triggered). */
        EXPECT_EQ(child_pid, info.si_pid);
 
-       /* Interrupt poll with SIGSTOP (which we'll need to handle). */
+       /* Interrupt nanosleep with SIGSTOP (which we'll need to handle). */
        ASSERT_EQ(0, kill(child_pid, SIGSTOP));
        ASSERT_EQ(0, ptrace(PTRACE_CONT, child_pid, NULL, 0));
        ASSERT_EQ(child_pid, waitpid(child_pid, &status, 0));
@@ -2110,7 +2152,7 @@ TEST(syscall_restart)
        ASSERT_EQ(0, ptrace(PTRACE_GETSIGINFO, child_pid, NULL, &info));
        EXPECT_EQ(getpid(), info.si_pid);
 
-       /* Restart poll with SIGCONT, which triggers restart_syscall. */
+       /* Restart nanosleep with SIGCONT, which triggers restart_syscall. */
        ASSERT_EQ(0, kill(child_pid, SIGCONT));
        ASSERT_EQ(0, ptrace(PTRACE_CONT, child_pid, NULL, 0));
        ASSERT_EQ(child_pid, waitpid(child_pid, &status, 0));
@@ -2124,16 +2166,25 @@ TEST(syscall_restart)
        ASSERT_EQ(SIGTRAP, WSTOPSIG(status));
        ASSERT_EQ(PTRACE_EVENT_SECCOMP, (status >> 16));
        ASSERT_EQ(0, ptrace(PTRACE_GETEVENTMSG, child_pid, NULL, &msg));
+
        ASSERT_EQ(0x200, msg);
        ret = get_syscall(_metadata, child_pid);
 #if defined(__arm__)
-       /* FIXME: ARM does not expose true syscall in registers. */
-       EXPECT_EQ(__NR_poll, ret);
-#else
-       EXPECT_EQ(__NR_restart_syscall, ret);
+       /*
+        * FIXME:
+        * - native ARM registers do NOT expose true syscall.
+        * - compat ARM registers on ARM64 DO expose true syscall.
+        */
+       ASSERT_EQ(0, uname(&utsbuf));
+       if (strncmp(utsbuf.machine, "arm", 3) == 0) {
+               EXPECT_EQ(__NR_nanosleep, ret);
+       } else
 #endif
+       {
+               EXPECT_EQ(__NR_restart_syscall, ret);
+       }
 
-       /* Write again to end poll. */
+       /* Write again to end test. */
        ASSERT_EQ(0, ptrace(PTRACE_CONT, child_pid, NULL, 0));
        ASSERT_EQ(1, write(pipefd[1], "!", 1));
        EXPECT_EQ(0, close(pipefd[1]));
index 8a3c29de7d49483a7a6aaa4e181b556a63a215a3..ff942ff7c9b367e8e306d6730c01fe92b1abd882 100644 (file)
@@ -19,6 +19,7 @@
  *   GNU General Public License for more details.
  */
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <time.h>
index 2df21b3bb26dbc9a946b4f5ec5038aec6f562ca8..e11968b3677ee9e8e229a8cbb7b39878afbc9485 100755 (executable)
@@ -20,13 +20,26 @@ done < /proc/meminfo
 if [ -n "$freepgs" ] && [ -n "$pgsize" ]; then
        nr_hugepgs=`cat /proc/sys/vm/nr_hugepages`
        needpgs=`expr $needmem / $pgsize`
-       if [ $freepgs -lt $needpgs ]; then
+       tries=2
+       while [ $tries -gt 0 ] && [ $freepgs -lt $needpgs ]; do
                lackpgs=$(( $needpgs - $freepgs ))
+               echo 3 > /proc/sys/vm/drop_caches
                echo $(( $lackpgs + $nr_hugepgs )) > /proc/sys/vm/nr_hugepages
                if [ $? -ne 0 ]; then
                        echo "Please run this test as root"
                        exit 1
                fi
+               while read name size unit; do
+                       if [ "$name" = "HugePages_Free:" ]; then
+                               freepgs=$size
+                       fi
+               done < /proc/meminfo
+               tries=$((tries - 1))
+       done
+       if [ $freepgs -lt $needpgs ]; then
+               printf "Not enough huge pages available (%d < %d)\n" \
+                      $freepgs $needpgs
+               exit 1
        fi
 else
        echo "no hugetlbfs support in kernel?"